/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package morzeovka;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;

/**
 *
 * @author kormanec4
 */
class Program {

    private Scanner sc;
    private String vstup;
    private String cisla;
    private String morzeovka;
    private HashMap<String, String> abeceda,abeceda2;
    private ArrayList<String> vystupy;

    public Program() {
        sc = new Scanner(System.in);
        abeceda = new HashMap();
        abeceda2 = new HashMap();
        naplnAbecedu();
        while(sc.hasNext()){
        vstup = sc.nextLine();
        cisla = "";
        morzeovka="";
        morzeovka += doMorzeovky();
        vystupy= new ArrayList();
        vystupy.add(zMorzeovky());
        }
        vypis();

    }

    private void naplnAbecedu() {
        abeceda.put("A", ".-");
        abeceda2.put(".-", "A");

        abeceda2.put("-...", "B");
        abeceda.put("B", "-...");

        abeceda2.put("-.-.", "C");
        abeceda.put("C", "-.-.");

        abeceda2.put("-..", "D");
        abeceda.put("D", "-..");

        abeceda2.put(".", "E");
        abeceda.put("E", ".");

        abeceda2.put("..-.", "F");
        abeceda.put("F", "..-.");

        abeceda2.put("--.", "G");
        abeceda.put("G", "--.");

        abeceda2.put("....", "H");
        abeceda.put("H", "....");

        abeceda2.put("..", "I");
        abeceda.put("I", "..");

        abeceda2.put(".---", "J");
        abeceda.put("J", ".---");

        abeceda2.put("-.-", "K");
        abeceda.put("K", "-.-");

        abeceda2.put(".-..", "L");
        abeceda.put("L", ".-..");

        abeceda2.put("--", "M");
        abeceda.put("M", "--");

        abeceda2.put("-.", "N");
        abeceda.put("N", "-.");

        abeceda2.put("---", "O");
        abeceda.put("O", "---");

        abeceda2.put(".--.", "P");
        abeceda.put("P", ".--.");

        abeceda2.put("--.-", "Q");
        abeceda.put("Q", "--.-");

        abeceda2.put(".-.", "R");
        abeceda.put("R", ".-.");

        abeceda2.put("...", "S");
        abeceda.put("S", "...");

        abeceda2.put("-", "T");
        abeceda.put("T", "-");

        abeceda2.put("..-", "U");
        abeceda.put("U", "..-");

        abeceda2.put("...-", "V");
        abeceda.put("V", "...-");

        abeceda2.put(".--", "W");
        abeceda.put("W", ".--");

        abeceda2.put("-..-", "X");
        abeceda.put("X", "-..-");

        abeceda2.put("-.--", "Y");
        abeceda.put("Y", "-.--");

        abeceda2.put("--..", "Z");
        abeceda.put("Z", "--..");

        abeceda2.put("..--", "_");
        abeceda.put("_", "..--");

        abeceda2.put(".-.-", ",");
        abeceda.put(",", ".-.-");

        abeceda2.put("---.", ".");
        abeceda.put(".", "---.");

        abeceda2.put("----", "?");
        abeceda.put("?", "----");
    }

    private String doMorzeovky() {
        StringBuilder morzeovka = new StringBuilder("");

        for (int i = 0; i < vstup.length(); i++) {
            String pom = ""+vstup.charAt(i);
            String znak = abeceda.get(pom);
            morzeovka.append(znak);
            cisla += (char) znak.length();
        }

        return morzeovka.toString();
    }

    private String zMorzeovky() {
        String vystup = "";
        int index = 0;
        int velkost;
        for (int i = cisla.length() - 1; i >= 0; i--) {
            velkost = (int) cisla.charAt(i);
            String pom = morzeovka.substring(index, index += velkost);
            
            vystup += abeceda2.get(pom);
        }
        return vystup;
    }

    private void vypis() {
        for (String string : vystupy) {
            System.out.println(string);
        }
    }
}
